typedef struct
{
  unsigned long numerator, denominator;
} rational;

#define INIT(r) {(r).numerator = 0; (r).denominator = 0;}
#define VALID(r) ((r).denominator != 0)

/* Comparison functions */
#ifndef bool
#include <stdbool.h>
#endif
bool are_equal (rational left, rational right);
bool is_lt (rational left, rational right);
bool is_le (rational left, rational right);
bool is_gt (rational left, rational right);
bool is_ge (rational left, rational right);
int cmp (rational left, rational right);

double float_of(const rational r);

#define MAX_RATIONAL_LEN 256

/* Input-Output functions */
rational text_to_rational (const char *textr);
char *rational_to_text (const rational r);	/* Do not forget to free() it */

unsigned long
gcd(unsigned long left, unsigned long right);
