#include <stdio.h>

#include "rational.h"

int
main(int argc, char **argv)
{
    rational        r1, r2;
    if (argc < 3) {
        printf("Usage: %s rational rational", argv[0]);
        return 1;
    }
    r1 = text_to_rational(argv[1]);
    if (!VALID(r1)) {
        printf("Invalid syntax for rational number in \"%s\"\n", argv[1]);
        return -1;
    }
    r2 = text_to_rational(argv[2]);
    if (!VALID(r2)) {
        printf("Invalid syntax for rational number in \"%s\"\n", argv[2]);
        return -1;
    }
    printf("Working with %s and %s\n", rational_to_text(r1), rational_to_text(r2));

    if (are_equal(r1, r2)) {
        printf("The two numbers are equal\n");
    } else {
        printf("The two numbers are different\n");
        if (is_lt(r1, r2))
            printf("The first is smaller\n");
        else
            printf("The first is larger\n");
        if (is_gt(r1, r2))
            printf("The first is larger\n");
        else
            printf("The first is smaller\n");
    }
    return 0;

}
